Getting Started with QueryBuilder Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the QueryBuilder module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.querybuilder.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-query-builder id="querybuilder"></smart-query-builder>

    Host container (id matches appendTo on Smart.QueryBuilder):

    <div id="querybuilderContainer"></div>

  5. Initialize after the module loads: define a const querybuilderOptions object, then either bind with Smart('#querybuilder', ...) on the semantic tag or use new Smart.QueryBuilder({ ...querybuilderOptions, appendTo: '#querybuilderContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.querybuilder.js';
    
    	const querybuilderOptions = { 
    				allowDrag: true,
    				fields: [
    					{ label: 'Id', dataField: 'id', dataType: 'number' },
    					{ label: 'Product', dataField: 'productName', dataType: 'string' },
    					{ label: 'Unit Price', dataField: 'price', dataType: 'number' },
    					{ label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
    					{ label: 'Available', dataField: 'available', dataType: 'boolean' }
    				]
    			};
    
    	// Option A - semantic <smart-query-builder> with id="querybuilder"
    	Smart('#querybuilder', class {
    		get properties() {
    			return querybuilderOptions;
    		}
    	});
    
    	// Option B - host div id="querybuilderContainer"
    	// const querybuilderInstance = new Smart.QueryBuilder({
    	// 	...querybuilderOptions,
    	// 	appendTo: '#querybuilderContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myQueryBuilder = new Smart.QueryBuilder('#querybuilder', querybuilderOptions);
    	// document.body.appendChild(myQueryBuilder);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.QueryBuilder('#querybuilder', querybuilderOptions) with appendChild, and document.createElement('smart-query-builder') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.QueryBuilder({ ...options, appendTo: '#...' }); new Smart.QueryBuilder('#querybuilder', querybuilderOptions) plus appendChild on the returned element; and document.createElement('smart-query-builder') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myQueryBuilder = new Smart.QueryBuilder('#querybuilder', querybuilderOptions)):

	const querybuilderOptions = { 
				allowDrag: true,
				fields: [
					{ label: 'Id', dataField: 'id', dataType: 'number' },
					{ label: 'Product', dataField: 'productName', dataType: 'string' },
					{ label: 'Unit Price', dataField: 'price', dataType: 'number' },
					{ label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
					{ label: 'Available', dataField: 'available', dataType: 'boolean' }
				]
			};
	const myQueryBuilder = new Smart.QueryBuilder('#querybuilder', querybuilderOptions);
	document.body.appendChild(myQueryBuilder);
	

Create with document.createElement('smart-query-builder'), assign properties (same as any custom element), then append:

	const querybuilderOptions = { 
				allowDrag: true,
				fields: [
					{ label: 'Id', dataField: 'id', dataType: 'number' },
					{ label: 'Product', dataField: 'productName', dataType: 'string' },
					{ label: 'Unit Price', dataField: 'price', dataType: 'number' },
					{ label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
					{ label: 'Available', dataField: 'available', dataType: 'boolean' }
				]
			};
	const querybuilder = document.createElement('smart-query-builder');
	Object.assign(querybuilder, querybuilderOptions);
	document.body.appendChild(querybuilder);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.querybuilder.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const querybuilderOptions = { 
				allowDrag: true,
				fields: [
					{ label: 'Id', dataField: 'id', dataType: 'number' },
					{ label: 'Product', dataField: 'productName', dataType: 'string' },
					{ label: 'Unit Price', dataField: 'price', dataType: 'number' },
					{ label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
					{ label: 'Available', dataField: 'available', dataType: 'boolean' }
				]
			};
		const querybuilder = new Smart.QueryBuilder({
			...querybuilderOptions,
			appendTo: '#querybuilderContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('querybuilder-container');
container.appendChild(querybuilder);
	

Remove from the DOM:

querybuilder.remove();
	

Set a property:

querybuilder.disabled = true;
querybuilder.theme = 'dark';
	

Get a property value:

const isDisabled = querybuilder.disabled;
const currentTheme = querybuilder.theme;
	

Invoke a method:

querybuilder.refresh();
querybuilder.focus();
	

Add event listener:

querybuilder.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.item);
});
	

Remove event listener:

const handleQueryBuilderEvent = (event) => {
    console.log('change triggered:', event.detail.item);
};

querybuilder.addEventListener('change', handleQueryBuilderEvent);
querybuilder.removeEventListener('change', handleQueryBuilderEvent);
	

Common Use Cases

  • Get filter expression

    Retrieve the current query as a filter

    const filter = queryBuilder.value;
  • Set initial conditions

    Pre-populate the query builder

    queryBuilder.value = [
      ['productName', 'contains', 'Tea'],
      'and',
      ['price', '>', 5]
    ];

Building a Filter Query

A complex filter query can be built by adding and manipulating conditions in the QueryBuilder's UI. In the element's initialization code, an array of fields to choose from is passed.

<!DOCTYPE html>
<html>
<head>
    <link rel="stylesheet" type="text/css" href="./../../source/styles/smart.default.css" />
    <script type="text/javascript" src="../../source/smart.element.js"></script>
    <script type="text/javascript" src="../../source/smart.button.js"></script>
    <script type="text/javascript" src="../../source/smart.scrollbar.js"></script>
    <script type="text/javascript" src="../../source/smart.menu.js"></script>
    <script type="text/javascript" src="../../source/smart.input.js"></script>
    <script type="text/javascript" src="../../source/smart.complex.js"></script>
    <script type="text/javascript" src="../../source/smart.math.js"></script>
    <script type="text/javascript" src="../../source/smart.numeric.js"></script>
    <script type="text/javascript" src="../../source/smart.numerictextbox.js"></script>
    <script type="text/javascript" src="../../source/smart.calendar.js"></script>
    <script type="text/javascript" src="../../source/smart.date.js"></script>
    <script type="text/javascript" src="../../source/smart.draw.js"></script>
    <script type="text/javascript" src="../../source/smart.dropdownlist.js"></script>
    <script type="text/javascript" src="../../source/smart.listbox.js"></script>
    <script type="text/javascript" src="../../source/smart.timepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.tooltip.js"></script>
    <script type="text/javascript" src="../../source/smart.datetimepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.checkbox.js"></script>
    <script type="text/javascript" src="../../source/smart.filterbuilder.js"></script>
    <script>
        Smart('#queryBuilder', class {
            get properties() {
                return {
                    allowDrag: true,
                    fields: [
                        { label: 'Id', dataField: 'id', dataType: 'number' },
                        { label: 'Product', dataField: 'productName', dataType: 'string' },
                        { label: 'Unit Price', dataField: 'price', dataType: 'number' },
                        { label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
                        { label: 'Available', dataField: 'available', dataType: 'boolean' }
                    ]
                };
            }
        });
    </script>
</head>
<body>
    <smart-query-builder id="queryBuilder"></smart-query-builder>
</body>
</html>

Demo

The shown operations result in the following value:

[[["price","<","300"]],"and",[["available","=",true],"or",["productName","startswith","app"]]]

Whether or not conditions can be dragged is controlled by the property allowDrag.

Setting value Initially

A QueryBuilder can be initialized with a predefined value, as shown in the example below:

<!DOCTYPE html>
<html>
<head>
    <link rel="stylesheet" type="text/css" href="./../../source/styles/smart.default.css" />
    <script type="text/javascript" src="../../source/smart.element.js"></script>
    <script type="text/javascript" src="../../source/smart.button.js"></script>
    <script type="text/javascript" src="../../source/smart.scrollbar.js"></script>
    <script type="text/javascript" src="../../source/smart.menu.js"></script>
    <script type="text/javascript" src="../../source/smart.input.js"></script>
    <script type="text/javascript" src="../../source/smart.complex.js"></script>
    <script type="text/javascript" src="../../source/smart.math.js"></script>
    <script type="text/javascript" src="../../source/smart.numeric.js"></script>
    <script type="text/javascript" src="../../source/smart.numerictextbox.js"></script>
    <script type="text/javascript" src="../../source/smart.calendar.js"></script>
    <script type="text/javascript" src="../../source/smart.date.js"></script>
    <script type="text/javascript" src="../../source/smart.draw.js"></script>
    <script type="text/javascript" src="../../source/smart.dropdownlist.js"></script>
    <script type="text/javascript" src="../../source/smart.listbox.js"></script>
    <script type="text/javascript" src="../../source/smart.timepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.tooltip.js"></script>
    <script type="text/javascript" src="../../source/smart.datetimepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.checkbox.js"></script>
    <script type="text/javascript" src="../../source/smart.filterbuilder.js"></script>
    <script>
        Smart('#queryBuilder', class {
            get properties() {
                return {
                    allowDrag: true,
                    fields: [
                        { label: 'Id', dataField: 'id', dataType: 'number' },
                        { label: 'Product', dataField: 'productName', dataType: 'string' },
                        { label: 'Unit Price', dataField: 'price', dataType: 'number' },
                        { label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
                        { label: 'Available', dataField: 'available', dataType: 'boolean' }
                    ],
                    value: [
                        [
                            ['purchased', '=', new Date(2026, 0, 4)],
                            'and',
                            ['productName', '<>', 'Monitors'],
                            'or',
                            ['productName', 'isblank']
                        ],
                        'and',
                        [
                            ['available', '=', true],
                            'and',
                            ['price', '<', 1300],
                        ]
                    ]
                };
            }
        });
    </script>
</head>
<body>
    <smart-query-builder id="queryBuilder"></smart-query-builder>
</body>
</html>

Demo

Custom Operations

Apart from standard comparison operations, such as Equals, Greater than, Less than, and Contains, users can define their own custom operations to use when creating queries with Smart.QueryBuilder:

Custom operations are defined by setting the customOperations property. Each member of this array can have the following fields:

  • label - label to be displayed in the operator box. Multiple operations with the same label can exist.
  • name - unique name of the operation
  • editorTemplate - callback function that creates a custom value editor
  • valueTemplate - callback function that displays the value after the edior has been closed
  • handleValue - callback function that handles the value returned by the editor when it is closed
  • hideValue - a boolean condition that specifies whether the operation requires a value or not

The name of the custom operation also has to be included in the filterOperations property/array of the field(s) it is applicable to.

<!DOCTYPE html>
<html>
<head>
    <link rel="stylesheet" type="text/css" href="./../../source/styles/smart.default.css" />
    <script type="text/javascript" src="../../source/smart.element.js"></script>
    <script type="text/javascript" src="../../source/smart.button.js"></script>
    <script type="text/javascript" src="../../source/smart.scrollbar.js"></script>
    <script type="text/javascript" src="../../source/smart.menu.js"></script>
    <script type="text/javascript" src="../../source/smart.input.js"></script>
    <script type="text/javascript" src="../../source/smart.complex.js"></script>
    <script type="text/javascript" src="../../source/smart.math.js"></script>
    <script type="text/javascript" src="../../source/smart.numeric.js"></script>
    <script type="text/javascript" src="../../source/smart.numerictextbox.js"></script>
    <script type="text/javascript" src="../../source/smart.calendar.js"></script>
    <script type="text/javascript" src="../../source/smart.date.js"></script>
    <script type="text/javascript" src="../../source/smart.draw.js"></script>
    <script type="text/javascript" src="../../source/smart.dropdownlist.js"></script>
    <script type="text/javascript" src="../../source/smart.listbox.js"></script>
    <script type="text/javascript" src="../../source/smart.timepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.tooltip.js"></script>
    <script type="text/javascript" src="../../source/smart.datetimepicker.js"></script>
    <script type="text/javascript" src="../../source/smart.checkbox.js"></script>
    <script type="text/javascript" src="../../source/smart.filterbuilder.js"></script>
    <script>
        Smart('#queryBuilder', class {
            get properties() {
                return {
                    customOperations: [
                        { label: 'Matches /^\d{7}$/g', name: '/^\d{7}$/g', hideValue: true },
                        {
                            label: 'Is valid',
                            name: 'isvalid',
                            editorTemplate: function (fieldType, value, fieldData) {
                                const editor1 = document.createElement('smart-radio-button'),
                                    editor2 = document.createElement('smart-radio-button'),
                                    container = document.createElement('div');

                                editor1.innerHTML = 'Yes';
                                editor2.innerHTML = 'No';
                                container.className = 'container';

                                if (typeof value !== 'boolean') {
                                    value = !!parseFloat(value);
                                }

                                editor1.checked = value;
                                editor2.checked = !value;

                                container.appendChild(editor1);
                                container.appendChild(editor2);

                                return container;
                            },
                            valueTemplate: function (editor, value) {
                                return value ? '<em>yes</em>' : '<em>no</em>';
                            },
                            handleValue: function (editor) {
                                const editors = editor.getElementsByTagName('smart-radio-button');

                                return editors[0].checked;
                            }
                        }],
                    fields: [
                        { label: 'Id', dataField: 'id', dataType: 'number', filterOperations: ['=', '<', '>', 'isvalid'] },
                        { label: 'Product', dataField: 'productName', dataType: 'string' },
                        { label: 'Product code', dataField: 'productCode', dataType: 'string', filterOperations: ['=', '/^\d{7}$/g'] },
                        { label: 'Unit Price', dataField: 'price', dataType: 'number' },
                        { label: 'Produced', dataField: 'produced', dataType: 'date', filterOperations: ['<', '>'] },
                        { label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
                        { label: 'Available', dataField: 'available', dataType: 'boolean' }
                    ],
                    value: [
                        [
                            ['productCode', '/^\d{7}$/g'],
                            'or',
                            ['id', 'isvalid', true]
                        ],
                        'and',
                        [
                            ['available', '=', true],
                            'and',
                            ['price', '<', 1300],
                        ]
                    ]
                }
            }
        });
    </script>
</head>
<body>
    <smart-query-builder id="queryBuilder"></smart-query-builder>
</body>
</html>

Demo

Operation Icons

Icons can be shown next to labels in the coparison operation box by setting the property showIcons to true. The icons property, on the other hand, defines CSS classes to be applied to each of the built-in operations. Icons for these classes are applied in the smart-query-builder style sheet.

Demo

To apply a custom icon to a particular operation, add CSS that defines the icon's appearance:

<style type="text/css">
    .custom-equals-icon:after {
        background-image: url("https://img.icons8.com/officel/16/000000/equal-sign.png");
    }
</style>

then set the respective icons field (in this case, '=', the Equals operation) to the name of the class defined in the CSS:

document.getElementById('queryBuilder').icons['='] = 'custom-equals-icon';

Troubleshooting

How do I get the filter expression?
Access queryBuilder.value to get the current conditions as an array that can be used for filtering data.
How do I add custom operators?
Define custom operators in the customOperations property for specific field types.

Accessibility

The QueryBuilder component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular QueryBuilder - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/querybuilder/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import QueryBuilderModule from smart-webcomponents-angular/querybuilder: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { QueryBuilderModule } from 'smart-webcomponents-angular/querybuilder';

4 Root component (standalone)

Add QueryBuilderModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { QueryBuilderComponent } from 'smart-webcomponents-angular/querybuilder';

import { QueryBuilderModule } from 'smart-webcomponents-angular/querybuilder';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ QueryBuilderModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('querybuilder', { read: QueryBuilderComponent, static: false }) querybuilder!: QueryBuilderComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    
    window.Smart('#queryBuilder', class {
        get properties() {
            return {
                allowDrag: true,
                fields: [
                    { label: 'Id', dataField: 'id', dataType: 'number' },
                    { label: 'Product', dataField: 'productName', dataType: 'string' },
                    { label: 'Unit Price', dataField: 'price', dataType: 'number' },
                    { label: 'Purchased', dataField: 'purchased', dataType: 'datetime' },
                    { label: 'Available', dataField: 'available', dataType: 'boolean' }
                ]
            };
        }
    });

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-query-builder as needed:

 <div class="demo-description">The Query Builder component allows you to build complex quieries through
    UI. The output of the component is a JSON object with the query.</div>
<smart-query-builder
#querybuilder id="queryBuilder"></smart-query-builder>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put QueryBuilderModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put QueryBuilderModule from smart-webcomponents-angular/querybuilder on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { QueryBuilderModule } from 'smart-webcomponents-angular/querybuilder';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, QueryBuilderModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Get filter expression

    Retrieve the current query as a filter

    const filter = queryBuilder.value;
  • Set initial conditions

    Pre-populate the query builder

    queryBuilder.value = [
      ['productName', 'contains', 'Tea'],
      'and',
      ['price', '>', 5]
    ];

Troubleshooting

How do I get the filter expression?
Access queryBuilder.value to get the current conditions as an array that can be used for filtering data.
How do I add custom operators?
Define custom operators in the customOperations property for specific field types.

Accessibility

The QueryBuilder component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React QueryBuilder Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/querybuilder/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { QueryBuilder } from 'smart-webcomponents-react/querybuilder';

function App() {
    // componentDidMount equivalent, if needed in the future
    // React.useEffect(() => {}, []);

    return (
        <div>
            <div className="demo-description">
                The Query Builder component allows you to build complex quieries through
                UI. The output of the component is a JSON object with the query.
            </div>
            <QueryBuilder
                allowDrag
                fields={[
                    {
                        label: 'Id',
                        dataField: 'id',
                        dataType: 'number'
                    },
                    {
                        label: 'Product',
                        dataField: 'productName',
                        dataType: 'string'
                    },
                    {
                        label: 'Unit Price',
                        dataField: 'price',
                        dataType: 'number'
                    },
                    {
                        label: 'Purchased',
                        dataField: 'purchased',
                        dataType: 'datetime'
                    },
                    {
                        label: 'Available',
                        dataField: 'available',
                        dataType: 'boolean'
                    }
                ]}
                id="queryBuilder"
            />
        </div>
    );
}

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Get filter expression

    Retrieve the current query as a filter

    const filter = queryBuilder.value;
  • Set initial conditions

    Pre-populate the query builder

    queryBuilder.value = [
      ['productName', 'contains', 'Tea'],
      'and',
      ['price', '>', 5]
    ];

Troubleshooting

How do I get the filter expression?
Access queryBuilder.value to get the current conditions as an array that can be used for filtering data.
How do I add custom operators?
Define custom operators in the customOperations property for specific field types.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { QueryBuilder, QueryBuilderProps } from 'smart-webcomponents-react/querybuilder';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The QueryBuilder component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.